import * as pb from "./pb";
import { Storage } from "./storage";
export declare class WeKeySMIME {
    protected socket: WebSocket;
    protected host: string;
    protected online: boolean;
    protected emitter: EventEmitter;
    onShowDigit: (num: string) => void;
    onHideDigit: (ok: boolean) => void;
    onAliveStatus: (online: boolean) => void;
    protected storage: Storage;
    constructor(host: string, onDigit: (num: string) => void);
    init(): Promise<void>;
    onSocketOpen(event: Event): void;
    onSocketClose(event: CloseEvent): void;
    protected onSocketMessage(event: MessageEvent): Promise<void>;
    protected setOnline(ok: boolean): void;
    echoEvent(e: pb.EchoEvent): Promise<pb.EchoEvent>;
    errorEvent(e: pb.ErrorEvent): Promise<pb.ErrorEvent>;
    statusEvent(e: pb.StatusEventReq): Promise<pb.StatusEventResp>;
    certListEvent(e: pb.CertListEventReq): Promise<pb.CertListEventResp>;
    emailInfoEvent(e: pb.EmailInfoEventReq): Promise<pb.EmailInfoEventResp>;
    disposeEmailEvent(e: pb.DisposeEmailEventReq): Promise<pb.DisposeEmailEventResp>;
    protected promiseEvent(mt: pb.EventType, e: any): Promise<any>;
    protected send(mt: pb.EventType, obj: object): void;
    protected unmarshalProto(buf: ArrayBuffer): Promise<pb.EchoEvent | pb.ErrorEvent | pb.CertListEventResp | pb.DisposeEmailEventResp>;
    protected marshalProto(mt: pb.EventType, msg: any): Promise<void>;
}
declare class EventEmitter {
    private callbacks;
    constructor();
    on(event: string, cb: (data: any) => any, cb2: (data: any) => any): void;
    emit(event: string, data: any): void;
    rm(event: string): void;
}
export {};
