import * as keychat from "@trustasia/keychat";
import { IDBPDatabase } from "idb";
import { HttpClient } from "../lib/client";
export interface remoteIdentity {
    signingKey: CryptoKey;
    exchangeKey: CryptoKey;
}
export declare class Storage {
    static STORAGE_NAME: string;
    static IDENTITY_STORAGE: string;
    static REMOTE_STORAGE: string;
    static IDENTITY: string;
    static REMOTE_IDENTITY: string;
    static create(endpoint: string): Promise<Storage>;
    protected db: IDBPDatabase;
    protected identity: keychat.Identity;
    protected remoteIdentity: remoteIdentity;
    protected client: HttpClient;
    cipher: keychat.Cipher;
    private constructor();
    isLoggedIn(): Promise<boolean>;
    handshakeServer(hideDigit: Function): Promise<string>;
    loadIdentity(): Promise<void>;
    saveIdentity(): Promise<void>;
    loadRemoteIdentity(): Promise<void>;
    saveRemoteIdentity(): Promise<void>;
}
